/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by http://code.google.com/p/protostuff/ ... DO NOT EDIT!
// Generated from protobuf

package org.apache.drill.exec.proto.beans;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

import com.dyuproject.protostuff.ByteString;
import com.dyuproject.protostuff.GraphIOUtil;
import com.dyuproject.protostuff.Input;
import com.dyuproject.protostuff.Message;
import com.dyuproject.protostuff.Output;
import com.dyuproject.protostuff.Schema;

public final class SaslMessage implements Externalizable, Message<SaslMessage>, Schema<SaslMessage>
{

    public static Schema<SaslMessage> getSchema()
    {
        return DEFAULT_INSTANCE;
    }

    public static SaslMessage getDefaultInstance()
    {
        return DEFAULT_INSTANCE;
    }

    static final SaslMessage DEFAULT_INSTANCE = new SaslMessage();

    
    private String mechanism;
    private ByteString data;
    private SaslStatus status;

    public SaslMessage()
    {
        
    }

    // getters and setters

    // mechanism

    public String getMechanism()
    {
        return mechanism;
    }

    public SaslMessage setMechanism(String mechanism)
    {
        this.mechanism = mechanism;
        return this;
    }

    // data

    public ByteString getData()
    {
        return data;
    }

    public SaslMessage setData(ByteString data)
    {
        this.data = data;
        return this;
    }

    // status

    public SaslStatus getStatus()
    {
        return status == null ? SaslStatus.SASL_UNKNOWN : status;
    }

    public SaslMessage setStatus(SaslStatus status)
    {
        this.status = status;
        return this;
    }

    // java serialization

    public void readExternal(ObjectInput in) throws IOException
    {
        GraphIOUtil.mergeDelimitedFrom(in, this, this);
    }

    public void writeExternal(ObjectOutput out) throws IOException
    {
        GraphIOUtil.writeDelimitedTo(out, this, this);
    }

    // message method

    public Schema<SaslMessage> cachedSchema()
    {
        return DEFAULT_INSTANCE;
    }

    // schema methods

    public SaslMessage newMessage()
    {
        return new SaslMessage();
    }

    public Class<SaslMessage> typeClass()
    {
        return SaslMessage.class;
    }

    public String messageName()
    {
        return SaslMessage.class.getSimpleName();
    }

    public String messageFullName()
    {
        return SaslMessage.class.getName();
    }

    public boolean isInitialized(SaslMessage message)
    {
        return true;
    }

    public void mergeFrom(Input input, SaslMessage message) throws IOException
    {
        for(int number = input.readFieldNumber(this);; number = input.readFieldNumber(this))
        {
            switch(number)
            {
                case 0:
                    return;
                case 1:
                    message.mechanism = input.readString();
                    break;
                case 2:
                    message.data = input.readBytes();
                    break;
                case 3:
                    message.status = SaslStatus.valueOf(input.readEnum());
                    break;
                default:
                    input.handleUnknownField(number, this);
            }   
        }
    }


    public void writeTo(Output output, SaslMessage message) throws IOException
    {
        if(message.mechanism != null)
            output.writeString(1, message.mechanism, false);

        if(message.data != null)
            output.writeBytes(2, message.data, false);

        if(message.status != null)
             output.writeEnum(3, message.status.number, false);
    }

    public String getFieldName(int number)
    {
        switch(number)
        {
            case 1: return "mechanism";
            case 2: return "data";
            case 3: return "status";
            default: return null;
        }
    }

    public int getFieldNumber(String name)
    {
        final Integer number = __fieldMap.get(name);
        return number == null ? 0 : number.intValue();
    }

    private static final java.util.HashMap<String,Integer> __fieldMap = new java.util.HashMap<String,Integer>();
    static
    {
        __fieldMap.put("mechanism", 1);
        __fieldMap.put("data", 2);
        __fieldMap.put("status", 3);
    }
    
}
